/* file: readdas16.c */
/* by Steve Rosenbluth */
/* copyright 2-2000 Jim Henson's Creature Shop */
/* compile with: gcc -Wall -O2 -o readdas16 readdas16.c */

/*----------------------------------------------------------------
    This source file is subject to the Mozilla Public
    License Version 1.0 (the "License"); you may not use this file
    except in compliance with the License. You may obtain a copy of
    the License at http://www.mozilla.org/MPL/

    Software distributed under the License is distributed on an "AS
    IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
    implied. See the License for the specific language governing
    rights and limitations under the License.
------------------------------------------------------------------*/

#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>                                 /* for exit */
#include "das16s-config.h"                      /* must include this for driver interface defs */
/*#include "../motion_engine/das16s-config.h"*/         /* for henson source tree only */


/*********************************/
int main (int argc, char *argv[]) 
{
    int in_file, numread, i;
    char dev_str[256] = {"/dev/das16s"};
    unsigned short result_packet[RESULT_PACK_SIZE_SI*MAX_SAMPLE_PACKETS];
    
    if ((in_file = open(dev_str, O_RDONLY|O_NONBLOCK)) < 0) {
        perror("");
        printf("Error opening %s\n",dev_str);
        exit(-1);
    }
    else
        printf("using %s.\nbuf addr is %p\n",dev_str,result_packet/*buf*/);

    printf("Asking for %d bytes... ",RESULT_PACK_SIZE_B);

    numread = read(in_file, result_packet, RESULT_PACK_SIZE_B);    /* read in one result packets worth of bytes */

    printf("got %d bytes\n",numread);

    if (numread > 0) 
    {
        printf("m:%d ",result_packet[HDR_MUX_OFFSET]);                      /* print current mux value */
        printf("d:%d ",result_packet[DIG_IN_OFFSET]);                       /* print digitals value */
        for(i=0; i < MAX_CHANNELS; i++)
            printf("%d ",result_packet[ADC_DATA_OFFSET+i]);
        printf("\n");
    }
    else if (numread == 0)
        printf("End of file (no samples)\n");
    else
        perror("Error reading:");

    return 0;
}
